# RaRa Linker

![Py3.10](https://img.shields.io/badge/python-3.10-green.svg)
![Py3.11](https://img.shields.io/badge/python-3.11-green.svg)
![Py3.12](https://img.shields.io/badge/python-3.12-green.svg)

**`rara-norm-linker`** is a  Python library for linking names, title, organizations and subject indices with taxonomy entries.

---

## ✨ Features  

TODO
---


## ⚡ Quick Start  

Get started with `rara-norm-linker` in just a few steps:

1. **Install the Package**  
   Ensure you're using Python 3.10 or above, then run:  
   ```bash
   pip install rara-norm-linker
   ```

2. **Import and Use**  
   Example usage to evaluate text:  

   ```python
   # TODO
   ```

---



## ⚙️ Installation Guide

Follow the steps below to install the `rara-norm-linker` package, either via `pip` or locally.

---

### Installation via `pip`

<details><summary>Click to expand</summary>

1. **Set Up Your Python Environment**  
   Create or activate a Python environment using Python **3.10** or above.

2. **Install the Package**  
   Run the following command:  
   ```bash
   pip install rara-norm-linker
   ```
</details>

---

### Local Installation

Follow these steps to install the `rara-norm-linker` package locally:  

<details><summary>Click to expand</summary>


1. **Clone the Repository**  
   Clone the repository and navigate into it:  
   ```bash
   git clone <repository-url>
   cd <repository-directory>
   ```

2. **Install Git LFS**   (?)
   Ensure you have Git LFS installed and initialized:  
   ```bash
   git lfs install
   ```

3. **Pull Git LFS Files** (?)
   Retrieve the large files tracked by Git LFS:  
   ```bash
   git lfs pull
   ```

4. **Set Up Python Environment**  
   Create or activate a Python environment using Python 3.10 or above. E.g:
   ```bash
   conda create -n py310 python==3.10
   conda activate py310
   ```

5. **Install Build Package**  
   Install the `build` package to enable local builds:  
   ```bash
   pip install build
   ```

6. **Build the Package**  
   Run the following command inside the repository:  
   ```bash
   python -m build
   ```

7. **Install the Package**  
   Install the built package locally:  
   ```bash
   pip install .
   ```

</details>

---

## 🚀 Testing Guide

Follow these steps to test the `rara-norm-linker` package.


### How to Test

<details><summary>Click to expand</summary>

1. **Clone the Repository**  
   Clone the repository and navigate into it:  
   ```bash
   git clone <repository-url>
   cd <repository-directory>
   ```

2. **Install Git LFS**   (?)
   Ensure Git LFS is installed and initialized:  
   ```bash
   git lfs install
   ```

3. **Pull Git LFS Files** (?)
   Retrieve the large files tracked by Git LFS:  
   ```bash
   git lfs pull
   ```

4. **Set Up Python Environment**  
   Create or activate a Python environment using Python 3.10 or above.

5. **Install Build Package**  
   Install the `build` package:  
   ```bash
   pip install build
   ```

6. **Build the Package**  
   Build the package inside the repository:  
   ```bash
   python -m build
   ```

7. **Install with Testing Dependencies**  
   Install the package along with its testing dependencies:  
   ```bash
   pip install .[testing]
   ```

8. **Run Tests**  
   Run the test suite from the repository root:  
   ```bash
   python -m pytest -v tests
   ```

---

</details>


## 📝 Documentation

Documentation can be found [here](DOCUMENTATION.md).


## 🔍 Usage Examples

TODO
